﻿using UnityEngine;
using System.Collections;

public class platform_movement : MonoBehaviour {
	
	//the force exerted on platform for going up
	public float ascendForce;
	//the rate with which the platform moves sideways. it is inverse proportional: the biger the number the slower it moves
	public float sideRate = 40f;
	
	//the projectile prefab
	public Rigidbody pelletPrefab;
	//initial velocity of the pellet when fired
	public float initialVelocity;
	//number of pellets fired
	int pelletsFired;
	
	//exit and restart buttons
	float buttonWidth	 = 100f;
	float buttonHeight = 50f;
	

	
	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
		
		//movement
		if(Input.GetAxis("Horizontal")!=0)
		{
			transform.Translate(Input.GetAxis("Horizontal")/sideRate,0f,0f,Space.World);
		}
		if(Input.GetAxis("Vertical")!=0)
		{
			transform.Translate(0f,0f,Input.GetAxis("Vertical")/sideRate,Space.World);
		}
		if(Input.GetKey("space"))
		{
			rigidbody.AddForce(0f,ascendForce,0f);
		}
		
		//firing pellets
		if(Input.GetButtonDown("Fire1"))
		{
			//instantiates the pellet at the turret and fires it up. 
			//the firing can be done in multiple of ways, depending of the wanted behaviour.
			//I am using rigidbody here
	
            Rigidbody pellet;
            pellet = Instantiate(pelletPrefab, transform.position + new Vector3(0f,1f,0f),  Quaternion.identity) as Rigidbody;
            pellet.velocity = transform.TransformDirection(Vector3.up * initialVelocity);
			
			//add +1 to this variable that stores the number of pellets fired
			pelletsFired++;
		}
		
		
	}
	
	//exit and restart buttons
	void OnGUI () 
	{
		if(GUI.Button ( new Rect (10f,10f,buttonWidth,buttonHeight), "Restart!"))
		{
			//print("Start Game");
			Application.LoadLevel("lvl1");
		}
		if(GUI.Button (new Rect (10,70,buttonWidth,buttonHeight), "Exit!"))
		{
			//print("Exit Game");
			Application.Quit();
		}
		
		//prints number of fired pellets as a gui element(label)
		GUI.Label(new Rect(150, 50, 100, 20), "Pellets: " + pelletsFired);
		
		//mute sound
		//for mute button
		bool M_Mute = false;
		if (GUI.Button (new Rect(10f,140f, buttonWidth, buttonHeight), "Mute"))
		{
      		M_Mute = !M_Mute;
      		AudioListener.pause = M_Mute;

		}
	}	
}
