using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class WaterThreadingEffect_beings : MonoBehaviour {
	
	//the prefab that will be spawned repeteadly used for waterthreading effect on the player
	public Transform prefabWave;
	public Transform prefabWaveGreen;
	
	//temp variables used for distance delay processing
	float waterfxDelta=0.1f;
	Vector3 previousPosition;
	
	//the distance delay between wave spawning
	public float waveDelay;
	//the time delay between wave spawning when in place. frequency in short
	public float staticWaveDelay;
	float tempStatic = 0f;
	
	//life of one wave
	public float life=2f;
	
	//the velocity threshold past which waves are created
	public float startOnVelocity;
	
	//the list that will hold all the "waves"
	List<Transform> waveS = new List<Transform>();
	//a list that holds the life span of each of them
	List<float> waveSLife = new List<float>();
	
	//temporary gameObject
	Transform tempObj;
	
	// Use this for initialization
	void Start () {
		previousPosition = transform.position;

	}
	
	
			
	void OnCollisionEnter(Collision collisionInfo) {
		//change the water threading effect to green
		if((collisionInfo.gameObject.name=="PLayer")||(collisionInfo.gameObject.tag=="being"))
		{
			prefabWave = prefabWaveGreen;
		}
	}		
	
	
	// Update is called once per frame
	void Update () {
		
		//if the being moves, then instantite waves
		if(rigidbody.velocity.magnitude>startOnVelocity)
		{
			waterfxDelta += Mathf.Abs((transform.position - previousPosition).magnitude);
			if(waterfxDelta>=waveDelay){
				tempObj = Instantiate(prefabWave,new Vector3(transform.position.x,0.0f,transform.position.z),prefabWave.rotation) as Transform;
				waveS.Add(tempObj) ;
				//Debug.Log(waveS.Count);
				waveSLife.Add(life);
				waterfxDelta=0F;
			}
			
			
		}
		//if the being in place, spawn much less frequent waves
		else
		{
			tempStatic += Time.deltaTime;
			if(tempStatic>=staticWaveDelay){
				tempObj = Instantiate(prefabWave,new Vector3(transform.position.x,0.0f,transform.position.z),prefabWave.rotation) as Transform;
				tempObj.GetComponent<ParticleSystem>().startLifetime = life;
				waveS.Add(tempObj) ;
				waveSLife.Add(life);
				tempStatic = 0f;
			}
		}
		
		//record this frame's positions for next frame's calculations
		previousPosition = transform.position;
		
		//handling of each wave
		if(waveS.Count>0)
		{
			for(int i=0;i<waveS.Count;i++)
			{
			

//				transparency over lifetime(fade-away).
				//waveS[i].renderer.material.color-=new Color(0f,0f,0f,Time.deltaTime*(1f/life));
				waveS[i].renderer.material.SetColor ("_TintColor", waveS[i].renderer.material.GetColor("_TintColor") - new Color(0f,0f,0f,Time.deltaTime*(1f/life)));
//				
				waveSLife[i]=waveSLife[i]-Time.deltaTime;
				if(waveSLife[i]<=0)
				{
					//next line is for destroying the instantiated material to prevent memory leak.they seem to build up with time
					DestroyImmediate(waveS[i].renderer.material); 
					Destroy(waveS[i].gameObject);
					waveS.RemoveAt(i);
					waveS.TrimExcess();
					waveSLife.RemoveAt(i);
					waveSLife.TrimExcess();
				}
			}	
		}
			
	}
}
